// Copyright (C) 2011 - DIGITEO - Michael Baudin
// Copyright (C) 2002 - INRIA - Xavier Jonsson
// Copyright (C) 2002 - INRIA - Serge Steer
//
// This file must be used under the terms of the CeCILL.
// This source file is licensed as described in the file COPYING, which
// you should have received as part of this distribution.  The terms
// are also available at
// http://www.cecill.info/licences/Licence_CeCILL_V2-en.txt

// <-- JVM NOT MANDATORY -->

//function to minimize
function f=rosenbrock(x)
  f=1+sum( 100*(x(2:$)-x(1:$-1)^2)^2 + (1-x(2:$))^2)
endfunction

[fopt,xopt,gopt]=optim(list(diffcode_CDcost,rosenbrock),[1;2;3;4]);
assert_checkalmostequal(fopt,1);
assert_checkalmostequal(xopt,[1;1;1;1]);
assert_checkalmostequal(gopt,[0;0;0;0],[],1.e-8);

//same problem defined using a loop
function f=rosenbrock1(x)
  f=1
  for k=2:size(x,"*")
    f=f+100*(x(k)-x(k-1)^2)^2 + (1-x(k))^2
  end
endfunction

[fopt,xopt,gopt]=optim(list(diffcode_CDcost,rosenbrock1),[1;2;3;4]);
assert_checkalmostequal(fopt,1);
assert_checkalmostequal(xopt,[1;1;1;1]);
assert_checkalmostequal(gopt,[0;0;0;0],[],1.e-8);

